## EDU.oswego.cs.dl.util.concurrent
Class ReentrantLock

    java.lang.Object
      EDU.oswego.cs.dl.util.concurrent.ReentrantLock

All Implemented Interfaces:
  Sync

    public class ReentrantLock

extends java.lang.Object
implements Sync

A lock with the same semantics as builtin Java synchronized locks: Once a thread has a lock, it can re-obtain it any number of times without blocking. The lock is made available to other threads when as many releases as acquires have occurred.

[ Introduction to this package. ]

Field Summary
`protected long` `holds_`
`protected java.lang.Thread` `owner_`

Fields inherited from interface EDU.oswego.cs.dl.util.concurrent.Sync
`ONE_CENTURY, ONE_DAY, ONE_HOUR, ONE_MINUTE, ONE_SECOND, ONE_WEEK, ONE_YEAR`

Constructor Summary
`ReentrantLock()`

Method Summary
`void` `acquire()` Wait (possibly forever) until successful passage.
`boolean` `attempt(long msecs)` Wait at most msecs to pass; report whether passed.
`long` `holds()` Return the number of unreleased acquires performed by the current thread.
`void` `release()` Release the lock.
`void` `release(long n)` Release the lock N times.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### owner_

    protected java.lang.Thread owner_

### holds_

    protected long holds_

Constructor Detail

### ReentrantLock

    public ReentrantLock()

Method Detail

### acquire

    public void acquire()
                 throws java.lang.InterruptedException

  Description copied from interface: `Sync`
  Wait (possibly forever) until successful passage. Fail only upon interuption. Interruptions always result in `clean' failures. On failure, you can be sure that it has not been acquired, and that no corresponding release should be performed. Conversely, a normal return guarantees that the acquire was successful.

  Specified by:
    `acquire` in interface `Sync`
  Throws:
    `java.lang.InterruptedException`

### attempt

    public boolean attempt(long msecs)
                    throws java.lang.InterruptedException

  Description copied from interface: `Sync`
  Wait at most msecs to pass; report whether passed.

  The method has best-effort semantics: The msecs bound cannot be guaranteed to be a precise upper bound on wait time in Java. Implementations generally can only attempt to return as soon as possible after the specified bound. Also, timers in Java do not stop during garbage collection, so timeouts can occur just because a GC intervened. So, msecs arguments should be used in a coarse-grained manner. Further, implementations cannot always guarantee that this method will return at all without blocking indefinitely when used in unintended ways. For example, deadlocks may be encountered when called in an unintended context.

  Specified by:
    `attempt` in interface `Sync`
  Parameters:
    `msecs` - the number of milleseconds to wait. An argument less than or equal to zero means not to wait at all. However, this may still require access to a synchronization lock, which can impose unbounded delay if there is a lot of contention among threads.
  Returns:
    true if acquired
  Throws:
    `java.lang.InterruptedException`

### release

    public void release()

  Release the lock.

  Specified by:
    `release` in interface `Sync`
  Throws:
    `java.lang.Error` - thrown if not current owner of lock

### release

    public void release(long n)

  Release the lock N times. `release(n)` is equivalent in effect to:

         for (int i = 0; i < n; ++i) release();

  Throws:
    `java.lang.Error` - thrown if not current owner of lock or has fewer than N holds on the lock

### holds

    public long holds()

  Return the number of unreleased acquires performed by the current thread. Returns zero if current thread does not hold lock.